local LDBThreat = LibStub("LibDataBroker-1.1"):NewDataObject("LDBThreat", { icon = "Interface\\TARGETINGFRAME\\UI-TargetingFrame-Skull.blp", type = "data source", text = "" })

local f = CreateFrame("Frame")

f:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE", "UpdateDisplay")
f:RegisterEvent("UNIT_THREAT_LIST_UPDATE", "UpdateDisplay" )
f:RegisterEvent("PLAYER_TARGET_CHANGED", "UpdateDisplay")
f:RegisterEvent("PARTY_MEMBERS_CHANGED", "UpdateDisplay")

local Color = {green = "ff00ff00", blue = "ff00ffff", red = "ffff0000", yellow = "ffffff00", orange = "ffffa500",}

local function GetThreat(unitId, mobId)
	local _, _, _, rawthreatpct, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not rawthreatpct then rawthreatpct = 0 end
	return rawthreatpct
end
	
local function GetThreatValue(unitId, mobId)
	local _, _, _, _, threatvalue = UnitDetailedThreatSituation(unitId, mobId)
	if not threatvalue then threatvalue = 0 end
	if threatvalue < 0 then threatvalue = threatvalue + 410065408 end
	return threatvalue
end

local function GetThreatStatus(unitId, mobId)
	local _,status,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	return status
end

local function GetClassColor(unit)
	local unitClass, _ = UnitClass(unit)
	local classColor = "ff848484" --Pets
	if unitClass == "Death Knight" then
		classColor = "ffC41F3B"
	
	elseif unitClass == "Druid" then
		classColor = "ffFF7D0A"
	
	elseif unitClass == "Hunter" then
		classColor = "ffABD473"
	
	elseif unitClass == "Mage" then
		classColor = "ff69CCF0"
	
	elseif unitClass == "Paladin" then
		classColor = "ffF58CBA"
	
	elseif unitClass == "Priest" then
		classColor = "ffFFFFFF"
	
	elseif unitClass == "Rogue" then
		classColor = "ffFFF569"
	
	elseif unitClass == "Shaman" then
		classColor = "ff2459FF"
	
	elseif unitClass == "Warlock" then
		classColor = "ff9482C9"
	
	elseif unitClass == "Warrior" then
		classColor = "ffC79C6E"
	end
	return classColor
end

local function UpdateDisplay()
	LDBThreat.text = "|cffC79C6ELDB|r-Threat"
	local _, _, _, _, tv = UnitDetailedThreatSituation("player", "target")
	local status = nil
	local nextUnit = ""
	local unitThreat = 0
	local nextThreat = 0
	local partynum = GetNumPartyMembers()
	local raidnum = GetNumRaidMembers()
	if (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "target") and not(UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Solo Target
	then			
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		if HasPetUI() then
			nextThreat = GetThreat("pet", "target")
			nextUnit = UnitName("pet")
			nextUnitColor = GetClassColor("pet")
		end
	elseif (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) -- Solo Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")			
		if HasPetUI() then
			nextThreat = GetThreat("pet", "targettarget")
			nextUnit = UnitName("pet")
			nextUnitColor = GetClassColor("pet")
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) --Raid Target
	then 
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "target") 	
				if unitThreat > nextThreat then 
					nextThreat = unitThreat	
					nextUnit = UnitName("raid"..i)
					nextUnitColor = GetClassColor("raid"..i)
				end
			unitThreat = GetThreat("raidpet"..i, "target")	
				if unitThreat > nextThreat then 
					nextThreat = unitThreat	
					nextUnit = UnitName("raidpet"..i)
					nextUnitColor = GetClassColor("pet")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > nextThreat then
					nextThreat = unitThreat
					nextUnit = UnitName("pet")
					nextUnitColor = GetClassColor("pet")
				end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Raid Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")				
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "targettarget") 	
				if unitThreat > nextThreat then 
					nextThreat = unitThreat	
					nextUnit = UnitName("raid"..i)
					nextUnitColor = GetClassColor("raid"..i)
				end
			unitThreat = GetThreat("raidpet"..i, "targettarget")	
				if unitThreat > nextThreat then 
					nextThreat = unitThreat	
					nextUnit = UnitName("raidpet"..i)
					nextUnitColor = GetClassColor("pet")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > nextThreat then
					nextThreat = unitThreat
					nextUnit = UnitName("pet")
					nextUnitColor = GetClassColor("pet")
				end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Party Target
	then 
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")	
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "target") 	
				if unitThreat > nextThreat then 
					nextThreat = unitThreat	
					nextUnit = UnitName("party"..i)
					nextUnitColor = GetClassColor("party"..i)
				end
			unitThreat = GetThreat("partypet"..i, "target")	
				if unitThreat > nextThreat then 
					nextThreat = unitThreat	
					nextUnit = UnitName("partypet"..i)
					nextUnitColor = GetClassColor("partypet"..i)
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > nextThreat then
					nextThreat = unitThreat
					nextUnit = UnitName("pet")
					nextUnitColor = GetClassColor("pet")
				end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Party Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")				
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "targettarget") 	
				if unitThreat > nextThreat then 
					nextThreat = unitThreat	
					nextUnit = UnitName("party"..i)
					nextUnitColor = GetClassColor("party"..i)
				end
			unitThreat = GetThreat("partypet"..i, "targettarget")	
				if unitThreat > nextThreat then 
					nextThreat = unitThreat	
					nextUnit = UnitName("partypet"..i)
					nextUnitColor = GetClassColor("partypet"..i)
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > nextThreat then
					nextThreat = unitThreat
					nextUnit = UnitName("pet")
					nextUnitColor = GetClassColor("pet")
				end
		end
	end
	if status == 0
	then
		LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.green, rawthreatpct )
		if rawthreatpct > 79 and rawthreatpct < 100
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.yellow, rawthreatpct )
		end
	elseif status == 1
	then
		LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.orange, rawthreatpct )
	elseif status == 2
	then
		LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.yellow )
		if nextThreat ~= 0
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% >|r |c%s%s.|r", Color.yellow, threatdiff, nextUnitColor, nextUnit )
		end	
	elseif status == 3
	then
		LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
		if nextThreat ~= 0
		then
			threatdiff = (100 - nextThreat)
			LDBThreat.text = string.format("|c%sAGGRO: %d %% >|r |c%s%s.|r", Color.red, threatdiff, nextUnitColor, nextUnit )
		end
	end
	if tv then
	if tv < 0 then --Fade or MI effect
		if UnitExists("targettarget") and not UnitCanAttack("player", "targettarget") and not UnitIsUnit("player", "targettarget")
		then
			tempthreat = floor((GetThreatValue("player", "target") / GetThreatValue("targettarget", "target")) * 100)
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.blue, tempthreat )
			if tempthreat > 130 
			then
				LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.blue )
			end
		end
	end
	end
end

function LDBThreat:OnTooltipShow()
	self:AddLine("|cffC79C6ELDB|r-Threat |cff00ff004.1b|r")
end

f:SetScript("OnEvent", function() UpdateDisplay() end )